# Pixel Invaders

[![PyPI](https://img.shields.io/pypi/v/pixel-invaders)](https://pypi.org/project/pixel-invaders/)
[![License](https://img.shields.io/github/license/LeoLeman555/Pixel_Invaders)](LICENSE)
![Status](https://img.shields.io/badge/status-stable-brightgreen)
![Built with Pyxel](https://img.shields.io/badge/built%20with-Pyxel%203.2.1+-purple)
![Code style: Black](https://img.shields.io/badge/code%20style-black-000000.svg)

Pixel Invaders is a retro arcade game where you pilot a spaceship to destroy waves of alien invaders. Designed in Python with the Pyxel library, it blends classic pixel art and action for a dynamic yet nostalgic experience.

## Prerequisites

- [Python 3.11+](https://www.python.org/)  
- [Pyxel 3.2.1+](https://github.com/kitao/pyxel) (installed automatically)

## Features

- Intense Gameplay:
    - Pilot a spaceship and defend the galaxy against waves of enemies.
    - Fire lasers or homing missiles with an overheat mechanism for strategic shooting.
    - Face powerful bosses every five waves with unique attack patterns.
    - Gain points, survive as long as possible, and upgrade your stats.
- Power-ups:
    - Speed Boost – Move faster.
    - Rapid Fire – Temporarily increase fire rate.
    - Extra Life – Gain an additional life.
    - Big Shot – Fire stronger projectiles.
    - Slow Down Enemies – Temporarily reduce enemy speed.
- Technical Aspects:
    - Object-Oriented Programming (OOP) for maintainability.
    - Configurable wave system using JSON.
    - Efficient asset management with optimized spritesheets.

## Installation

1. To install Pixel Invaders, simply run:
   ```bash
   pip install pixel-invaders
   ```
2. Once installed, launch the game with:
   ```bash
   pixel-invaders
   ```

## Controls

| Action        | Key               |
|---------------|-------------------|
| Move Left     | Left Arrow or A/Q |
| Move Right    | Right Arrow or D  |
| Fire          | Spacebar          |

> Note: The game supports both QWERTY (A/D) and AZERTY (Q/D) keyboard layouts.

## License

This project is licensed under the MIT License. See the [LICENSE](https://github.com/LeoLeman555/Pixel_Invaders/blob/main/LICENSE) file for more details.

## Source Code

The source code is available [here](https://github.com/LeoLeman555/Pixel_Invaders).

## Credits
   - Code and Game design: [Léo Leman](https://github.com/LeoLeman555)
   - Spritesheets and Art: Santi
   - Built with: [Pyxel](https://github.com/kitao/pyxel)

Special thanks to the open-source community for tools and inspiration!

## Contact

For questions or feedback, feel free to reach out:

- GitHub: [Léo Leman](https://github.com/LeoLeman555)